## ableton-link 1.0.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(Link)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

#   ___        _   _
#  / _ \ _ __ | |_(_) ___  _ __  ___
# | | | | '_ \| __| |/ _ \| '_ \/ __|
# | |_| | |_) | |_| | (_) | | | \__ \
#  \___/| .__/ \__|_|\___/|_| |_|___/
#       |_|

# Note: Please use the LINK_* prefix for all project-specific options
option(LINK_BUILD_QT_EXAMPLES "Build examples (Requires Qt)" OFF)

if(UNIX)
  set(LINK_WORD_SIZE "64" CACHE STRING "Set the word size (must be either 32 or 64)")
  option(LINK_ENABLE_ASAN "Build with Address Sanitizier (ASan)" OFF)
endif()

if(WIN32)
  if(${CMAKE_GENERATOR} MATCHES "Win64")
    set(LINK_WORD_SIZE "64")
  else()
    set(LINK_WORD_SIZE "32")
  endif()

  option(LINK_BUILD_ASIO "Build example applications with ASIO driver" ON)
  option(LINK_BUILD_VLD "Build with VLD support (VLD must be installed separately)" OFF)
endif()

#  ____       _   _
# |  _ \ __ _| |_| |__  ___
# | |_) / _` | __| '_ \/ __|
# |  __/ (_| | |_| | | \__ \
# |_|   \__,_|\__|_| |_|___/
#

# Other CMake files must be included only after declaring build options
include(cmake_include/ConfigureCompileFlags.cmake)
include(cmake_include/ConfigureWordSize.cmake)
include(cmake_include/CatchConfig.cmake)
include(AbletonLinkConfig.cmake)

add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(examples)

#  ____
# / ___| _   _ _ __ ___  _ __ ___   __ _ _ __ _   _
# \___ \| | | | '_ ` _ \| '_ ` _ \ / _` | '__| | | |
#  ___) | |_| | | | | | | | | | | | (_| | |  | |_| |
# |____/ \__,_|_| |_| |_|_| |_| |_|\__,_|_|   \__, |
#                                             |___/

message(STATUS "Build options")

get_cmake_property(all_variables VARIABLES)
string(REGEX MATCHALL "(^|;)LINK_[A-Z_]+" link_variables "${all_variables}")
foreach(variable ${link_variables})
  message("   ${variable}: ${${variable}}")
endforeach()

message(STATUS "Build configuration")

if(CMAKE_BUILD_TYPE)
  message("   Build type: ${CMAKE_BUILD_TYPE}")
else()
  message("   Build type: Set by IDE")
endif()

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(LinkExamples)

#     _    ____ ___ ___
#    / \  / ___|_ _/ _ \
#   / _ \ \___ \| | | | |
#  / ___ \ ___) | | |_| |
# /_/   \_\____/___\___/
#

if(WIN32)
  function(configure_asio asio_sdk_path_OUT)
    # ASIO-related path/file variables
    set(asio_download_root "https://www.steinberg.net/sdk_downloads")
    set(asio_file_name "asiosdk2.3.zip")
    set(asio_dir_name "ASIOSDK2.3")
    set(asio_working_dir "${CMAKE_BINARY_DIR}/modules")
    set(asio_output_path "${asio_working_dir}/${asio_file_name}")

    message(STATUS "Downloading ASIO SDK")
    file(DOWNLOAD "${asio_download_root}/${asio_file_name}" ${asio_output_path})
    file(SHA1 ${asio_output_path} asio_zip_hash)
    message("   ASIO SDK SHA1: ${asio_zip_hash}")

    message("   Extracting ASIO SDK")
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar "xf" ${asio_output_path} --format=zip
      WORKING_DIRECTORY ${asio_working_dir}
      INPUT_FILE ${asio_output_path}
    )

    # Set the ASIO SDK path for the caller
    set(${asio_sdk_path_OUT} "${asio_working_dir}/${asio_dir_name}" PARENT_SCOPE)
  endfunction()
endif()

#     _             _ _
#    / \  _   _  __| (_) ___
#   / _ \| | | |/ _` | |/ _ \
#  / ___ \ |_| | (_| | | (_) |
# /_/   \_\__,_|\__,_|_|\___/
#

set(linkhut_audio_SOURCES)

if(APPLE)
  set(linkhut_audio_SOURCES
    linkaudio/AudioPlatform_CoreAudio.hpp
    linkaudio/AudioPlatform_CoreAudio.cpp
  )
elseif(WIN32)
  if(LINK_BUILD_ASIO)
    configure_asio(asio_sdk_path)

    include_directories(${asio_sdk_path}/common)
    include_directories(${asio_sdk_path}/host)
    include_directories(${asio_sdk_path}/host/pc)

    set(linkhut_audio_SOURCES
      ${asio_sdk_path}/common/asio.cpp
      ${asio_sdk_path}/host/asiodrivers.cpp
      ${asio_sdk_path}/host/pc/asiolist.cpp
      linkaudio/AudioPlatform_Asio.hpp
      linkaudio/AudioPlatform_Asio.cpp
    )
  else()
    message(WARNING "LinkHut has been configured to be built with the WASAPI audio "
      "driver. This driver is considered experimental and has problems with low-latency "
      "playback. Please consider using the ASIO driver instead.")
    set(linkhut_audio_SOURCES
      linkaudio/AudioPlatform_Wasapi.hpp
      linkaudio/AudioPlatform_Wasapi.cpp
    )
  endif()
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(linkhut_audio_SOURCES
    linkaudio/AudioPlatform_Portaudio.hpp
    linkaudio/AudioPlatform_Portaudio.cpp
  )
endif()

include_directories(linkaudio)
source_group("Audio Sources" FILES ${linkhut_audio_SOURCES})

#   ____
#  / ___|___  _ __ ___  _ __ ___   ___  _ __
# | |   / _ \| '_ ` _ \| '_ ` _ \ / _ \| '_ \
# | |__| (_) | | | | | | | | | | | (_) | | | |
#  \____\___/|_| |_| |_|_| |_| |_|\___/|_| |_|
#

function(configure_linkhut_executable target)
  if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    target_link_libraries(${target} pthread)
  endif()

  target_link_libraries(${target} Ableton::Link)

  target_set_word_size(${target})
endfunction()

function(configure_linkhut_audio_sources target)
  if(APPLE)
    target_link_libraries(${target} "-framework AudioUnit")
    target_compile_definitions(${target} PRIVATE
      -DLINKHUT_AUDIO_PLATFORM_COREAUDIO=1
    )
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    target_link_libraries(${target} asound portaudio)
    target_compile_definitions(${target} PRIVATE
      -DLINKHUT_AUDIO_PLATFORM_PORTAUDIO=1
    )
  elseif(WIN32)
    if(LINK_BUILD_ASIO)
      # ASIO uses lots of old-school string APIs from the C stdlib
      add_definitions("/D_CRT_SECURE_NO_WARNINGS")
      target_compile_definitions(${target} PRIVATE
        -DLINKHUT_AUDIO_PLATFORM_ASIO=1
      )
    else()
      target_compile_definitions(${target} PRIVATE
        -DLINKHUT_AUDIO_PLATFORM_WASAPI=1
      )
      endif()

    target_link_libraries(${target} winmm)
  endif()

endfunction()

if(WIN32)
  # When building LinkHut, additional warnings are generated from third-party frameworks
  set(extra_ignored_warnings_LIST
    "/wd4127" # conditional expression is constant
    "/wd4702" # unreachable code
  )
  if(LINK_BUILD_ASIO)
    set(extra_ignored_warnings_LIST
      ${extra_ignored_warnings_LIST}
      "/wd4267" # 'argument': conversion from '?' to '?', possible loss of data
      "/wd4477" # 'printf': format string '%?' requires an argument of type '?'
    )
  endif()
  string(REPLACE ";" " " extra_ignored_warnings "${extra_ignored_warnings_LIST}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${extra_ignored_warnings}")
endif()

#  _     _       _    _   _       _
# | |   (_)_ __ | | _| | | |_   _| |_
# | |   | | '_ \| |/ / |_| | | | | __|
# | |___| | | | |   <|  _  | |_| | |_
# |_____|_|_| |_|_|\_\_| |_|\__,_|\__|
#

set(linkhut_HEADERS
  linkaudio/AudioEngine.hpp
  linkaudio/AudioPlatform.hpp
  ${link_HEADERS}
)

set(linkhut_SOURCES
  linkaudio/AudioEngine.cpp
  linkhut/main.cpp
)

add_executable(LinkHut
  ${linkhut_HEADERS}
  ${linkhut_SOURCES}
  ${linkhut_audio_SOURCES}
)
configure_linkhut_audio_sources(LinkHut)
configure_linkhut_executable(LinkHut)
source_group("LinkHut" FILES ${linkhut_HEADERS} ${linkhut_SOURCES})

#   ___  _     _       _    _   _       _
#  / _ \| |   (_)_ __ | | _| | | |_   _| |_
# | | | | |   | | '_ \| |/ / |_| | | | | __|
# | |_| | |___| | | | |   <|  _  | |_| | |_
#  \__\_\_____|_|_| |_|_|\_\_| |_|\__,_|\__|
#

if(LINK_BUILD_QT_EXAMPLES)

  set(CMAKE_AUTOMOC ON)
  set(CMAKE_INCLUDE_CURRENT_DIR ON)

  find_package(Qt5Quick REQUIRED)

  set(qlinkhut_HEADERS
    linkaudio/AudioEngine.hpp
    linkaudio/AudioPlatform.hpp
    qlinkhut/Controller.hpp
    ${link_HEADERS}
  )

  set(qlinkhut_SOURCES
    linkaudio/AudioEngine.cpp
    qlinkhut/Controller.cpp
    qlinkhut/main.cpp
    ${link_SOURCES}
  )
  source_group("QLinkHut" FILES ${qlinkhut_HEADERS} ${qlinkhut_SOURCES})
  qt5_add_resources(UI_RESOURCES qlinkhut/resources.qrc)

  add_executable(QLinkHut
    ${qlinkhut_HEADERS}
    ${qlinkhut_SOURCES}
    ${linkhut_audio_SOURCES}
    ${UI_RESOURCES}
  )
  target_link_libraries(QLinkHut Qt5::Quick)
  configure_linkhut_audio_sources(QLinkHut)
  configure_linkhut_executable(QLinkHut)

  # A silent version of QLinkHut that uses the Link application context instead of
  # the audio buffer context. It is the same as QLinkHut except that it doesn't
  # generate sound.

  add_executable(QLinkHutSilent
    ${qlinkhut_HEADERS}
    ${qlinkhut_SOURCES}
    linkaudio/AudioPlatform_Dummy.hpp
    ${UI_RESOURCES}
  )
  target_link_libraries(QLinkHutSilent Qt5::Quick)

  target_compile_definitions(QLinkHutSilent PRIVATE
    -DLINKHUT_AUDIO_PLATFORM_DUMMY=1
  )
  if(UNIX)
    set_target_properties(QLinkHutSilent
      PROPERTIES
      COMPILE_FLAGS "-Wno-unused"
    )
  endif()

  configure_linkhut_executable(QLinkHutSilent)
endif()

=== include/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(LinkCore)

#   ____
#  / ___|___  _ __ ___
# | |   / _ \| '__/ _ \
# | |__| (_) | | |  __/
#  \____\___/|_|  \___|
#

set(link_core_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/link)
set(link_core_HEADERS
  ${link_core_DIR}/Beats.hpp
  ${link_core_DIR}/ClientSessionTimelines.hpp
  ${link_core_DIR}/Controller.hpp
  ${link_core_DIR}/Gateway.hpp
  ${link_core_DIR}/GhostXForm.hpp
  ${link_core_DIR}/HostTimeFilter.hpp
  ${link_core_DIR}/Kalman.hpp
  ${link_core_DIR}/LinearRegression.hpp
  ${link_core_DIR}/Measurement.hpp
  ${link_core_DIR}/MeasurementEndpointV4.hpp
  ${link_core_DIR}/MeasurementService.hpp
  ${link_core_DIR}/NodeId.hpp
  ${link_core_DIR}/NodeState.hpp
  ${link_core_DIR}/PayloadEntries.hpp
  ${link_core_DIR}/Peers.hpp
  ${link_core_DIR}/PeerState.hpp
  ${link_core_DIR}/Phase.hpp
  ${link_core_DIR}/PingResponder.hpp
  ${link_core_DIR}/SessionId.hpp
  ${link_core_DIR}/Sessions.hpp
  ${link_core_DIR}/Tempo.hpp
  ${link_core_DIR}/Timeline.hpp
  ${link_core_DIR}/v1/Messages.hpp
  PARENT_SCOPE
)

#  ____  _
# |  _ \(_)___  ___ _____   _____ _ __ _   _
# | | | | / __|/ __/ _ \ \ / / _ \ '__| | | |
# | |_| | \__ \ (_| (_) \ V /  __/ |  | |_| |
# |____/|_|___/\___\___/ \_/ \___|_|   \__, |
#                                      |___/

set(link_discovery_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/discovery)
set(link_discovery_HEADERS
  ${link_discovery_DIR}/InterfaceScanner.hpp
  ${link_discovery_DIR}/IpV4Interface.hpp
  ${link_discovery_DIR}/MessageTypes.hpp
  ${link_discovery_DIR}/NetworkByteStreamSerializable.hpp
  ${link_discovery_DIR}/Payload.hpp
  ${link_discovery_DIR}/PeerGateway.hpp
  ${link_discovery_DIR}/PeerGateways.hpp
  ${link_discovery_DIR}/Service.hpp
  ${link_discovery_DIR}/Socket.hpp
  ${link_discovery_DIR}/UdpMessenger.hpp
  ${link_discovery_DIR}/v1/Messages.hpp
  PARENT_SCOPE
)

#  ____  _       _    __
# |  _ \| | __ _| |_ / _| ___  _ __ _ __ ___
# | |_) | |/ _` | __| |_ / _ \| '__| '_ ` _ \
# |  __/| | (_| | |_|  _| (_) | |  | | | | | |
# |_|   |_|\__,_|\__|_|  \___/|_|  |_| |_| |_|
#

set(link_platform_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/platforms)
set(link_platform_HEADERS
  ${link_platform_DIR}/Config.hpp
  ${link_platform_DIR}/asio/AsioService.hpp
  ${link_platform_DIR}/asio/AsioTimer.hpp
  ${link_platform_DIR}/asio/AsioWrapper.hpp
  ${link_platform_DIR}/asio/Context.hpp
  ${link_platform_DIR}/asio/PooledHandlerContext.hpp
  ${link_platform_DIR}/asio/Socket.hpp
  ${link_platform_DIR}/asio/Util.hpp
)

if(UNIX)
  set(link_platform_HEADERS
    ${link_platform_HEADERS}
    ${link_platform_DIR}/posix/ScanIpIfAddrs.hpp
  )

  if(APPLE)
    set(link_platform_HEADERS
      ${link_platform_HEADERS}
      ${link_platform_DIR}/darwin/Clock.hpp
      ${link_platform_DIR}/darwin/Darwin.hpp
    )
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set(link_platform_HEADERS
      ${link_platform_HEADERS}
      ${link_platform_DIR}/linux/Linux.hpp
      ${link_platform_DIR}/stl/Clock.hpp
    )
  endif()
elseif(WIN32)
  set(link_platform_HEADERS
    ${link_platform_HEADERS}
    ${link_platform_DIR}/windows/Clock.hpp
    ${link_platform_DIR}/windows/ScanIpIfAddrs.hpp
  )
endif()
set(link_platform_HEADERS
  ${link_platform_HEADERS}
  PARENT_SCOPE
)

#  _   _ _   _ _
# | | | | |_(_) |
# | | | | __| | |
# | |_| | |_| | |
#  \___/ \__|_|_|
#

set(link_util_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/util)
set(link_util_HEADERS
  ${link_util_DIR}/Injected.hpp
  ${link_util_DIR}/Log.hpp
  ${link_util_DIR}/SafeAsyncHandler.hpp
  ${link_util_DIR}/SampleTiming.hpp
  PARENT_SCOPE
)

#  _____                       _           _
# | ____|_  ___ __   ___  _ __| |_ ___  __| |
# |  _| \ \/ / '_ \ / _ \| '__| __/ _ \/ _` |
# | |___ >  <| |_) | (_) | |  | ||  __/ (_| |
# |_____/_/\_\ .__/ \___/|_|   \__\___|\__,_|
#            |_|

# This list contains all of the headers needed by most Link projects.
# Usually, just adding this variable to your linker targets will place
# all relevant Link headers in your project.
set(link_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton)
set(link_HEADERS
  ${link_core_HEADERS}
  ${link_discovery_HEADERS}
  ${link_platform_HEADERS}
  ${link_util_HEADERS}
  ${link_DIR}/Link.hpp
  ${link_DIR}/Link.ipp
  PARENT_SCOPE
)

set(link_test_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/test)
set(link_test_HEADERS
  ${link_discovery_DIR}/test/Interface.hpp
  ${link_discovery_DIR}/test/PayloadEntries.hpp
  ${link_discovery_DIR}/test/Socket.hpp
  ${link_util_DIR}/test/IoService.hpp
  ${link_util_DIR}/test/Timer.hpp
  ${link_test_DIR}/CatchWrapper.hpp
  ${link_test_DIR}/serial_io/Context.hpp
  ${link_test_DIR}/serial_io/Fixture.hpp
  ${link_test_DIR}/serial_io/SchedulerTree.hpp
  ${link_test_DIR}/serial_io/Timer.hpp
  PARENT_SCOPE
)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(LinkTest)

#  ____
# / ___|  ___  _   _ _ __ ___ ___  ___
# \___ \ / _ \| | | | '__/ __/ _ \/ __|
#  ___) | (_) | |_| | | | (_|  __/\__ \
# |____/ \___/ \__,_|_|  \___\___||___/
#

set(link_discovery_test_SOURCES
  ableton/discovery/tst_InterfaceScanner.cpp
  ableton/discovery/tst_Payload.cpp
  ableton/discovery/tst_PeerGateway.cpp
  ableton/discovery/tst_PeerGateways.cpp
  ableton/discovery/tst_UdpMessenger.cpp
  ableton/discovery/v1/tst_Messages.cpp
)

set(link_core_test_SOURCES
  ableton/link/tst_Beats.cpp
  ableton/link/tst_ClientSessionTimelines.cpp
  ableton/link/tst_Controller.cpp
  ableton/link/tst_HostTimeFilter.cpp
  ableton/link/tst_Kalman.cpp
  ableton/link/tst_LinearRegression.cpp
  ableton/link/tst_Measurement.cpp
  ableton/link/tst_Peers.cpp
  ableton/link/tst_Phase.cpp
  ableton/link/tst_PingResponder.cpp
  ableton/link/tst_Tempo.cpp
  ableton/link/tst_Timeline.cpp
)

set(link_test_SOURCES
  ableton/test/catch/CatchMain.cpp
  ableton/test/serial_io/SchedulerTree.cpp
)

#  ____                              ____
# / ___|  ___  _   _ _ __ ___ ___   / ___|_ __ ___  _   _ _ __  ___
# \___ \ / _ \| | | | '__/ __/ _ \ | |  _| '__/ _ \| | | | '_ \/ __|
#  ___) | (_) | |_| | | | (_|  __/ | |_| | | | (_) | |_| | |_) \__ \
# |____/ \___/ \__,_|_|  \___\___|  \____|_|  \___/ \__,_| .__/|___/
#                                                        |_|

source_group("Link" FILES
  ${link_core_HEADERS}
)

source_group("Discovery" FILES
  ${link_discovery_HEADERS}
)

source_group("Platform" FILES
  ${link_platform_HEADERS}
)

source_group("Util" FILES
  ${link_util_HEADERS}
)

source_group("Test Utils" FILES
  ${link_test_HEADERS}
  ${link_test_SOURCES}
)

#  _____                    _
# |_   _|_ _ _ __ __ _  ___| |_  ___
#   | |/ _` | '__/ _` |/ _ \ __|/ __|
#   | | (_| | | | (_| |  __/ |_ \__ \
#   |_|\__,_|_|  \__, |\___|\__||___/
#                |___/

function(configure_link_test_executable target)
  if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    target_link_libraries(${target} pthread)
  endif()
  target_link_libraries(${target} Catch::Catch Ableton::Link)

  target_set_word_size(${target})
endfunction()

# For the LinkCore test suite, we add header dependencies individually so that
# the source groups above are shown correctly to the project. However, most
# other projects integrating Link won't need this functionality, and they should
# should just depend on ${link_HEADERS}.
add_executable(LinkCoreTest
  ${link_core_HEADERS}
  ${link_discovery_HEADERS}
  ${link_platform_HEADERS}
  ${link_util_HEADERS}
  ${link_test_HEADERS}

  ${link_core_test_SOURCES}
  ${link_test_SOURCES}
)
configure_link_test_executable(LinkCoreTest)

# For the LinkDiscovery test suite, we only add dependencies on the headers
# necessary to compile these tests, since the Discovery feature should not have
# dependencies on the Link core code.  Normal targets should always use
# ${link_HEADERS} for their dependencies.
add_executable(LinkDiscoveryTest
  ${link_discovery_HEADERS}
  ${link_platform_HEADERS}
  ${link_util_HEADERS}
  ${link_test_HEADERS}

  ${link_discovery_test_SOURCES}
  ${link_test_SOURCES}
)
configure_link_test_executable(LinkDiscoveryTest)

=== debian/changelog ===
ableton-link (1.0.0+dfsg-2) unstable; urgency=medium

  * Patch to disable '-m32/-m64' by default. (Closes: #842410)
  * Fixed install-path for headers
  * Fixed Vcs-Git link

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 30 Oct 2016 20:49:33 +0100

ableton-link (1.0.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #842107)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 27 Oct 2016 13:25:14 +0200

=== debian/control ===
Source: ableton-link
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
Build-Depends: debhelper (>= 9),
 cmake,
 catch,
 libasio-dev,
 libjack-dev,
 qtdeclarative5-dev,
Standards-Version: 3.9.8
Homepage: https://www.ableton.com/en/link/
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/ableton-link.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/ableton-link.git

Package: ableton-link-dev
Architecture: all
Depends:
 ${misc:Depends},
 libasio-dev,
Description: synchronizes musical applications on multiple devices - development
 Ableton Link, a technology that synchronizes musical beat, tempo, and phase
 across multiple applications running on one or more devices. Applications on
 devices connected to a local network discover each other automatically and form
 a musical session in which each participant can perform independently: anyone
 can start or stop while still staying in time. Anyone can change the tempo, the
 others will follow. Anyone can join or leave without disrupting the session.
 .
 Ableton Link is implemented as a header-only C++-library.
 This package contains the development files.

Package: ableton-link-utils
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: synchronizes musical applications on multiple devices - cmdline utils
 Ableton Link, a technology that synchronizes musical beat, tempo, and phase
 across multiple applications running on one or more devices. Applications on
 devices connected to a local network discover each other automatically and form
 a musical session in which each participant can perform independently: anyone
 can start or stop while still staying in time. Anyone can change the tempo, the
 others will follow. Anyone can join or leave without disrupting the session.
 .
 This package contains cmdline utilities to check synchronisation.

Package: ableton-link-utils-gui
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 qml-module-qtquick-controls,
Description: synchronizes musical applications on multiple devices - GUI utils
 Ableton Link, a technology that synchronizes musical beat, tempo, and phase
 across multiple applications running on one or more devices. Applications on
 devices connected to a local network discover each other automatically and form
 a musical session in which each participant can perform independently: anyone
 can start or stop while still staying in time. Anyone can change the tempo, the
 others will follow. Anyone can join or leave without disrupting the session.
 .
 This package contains GUI utilities to check synchronisation.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

QMANPAGES = debian/QLinkHut.1 debian/QLinkHutSilent.1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DLINK_BUILD_QT_EXAMPLES=ON \
		-DLINK_BUILD_JACK=ON \
		$(empty)

$(QMANPAGES): debian/LinkHut.1
	cp $^ $@

override_dh_auto_build: $(QMANPAGES)
	dh_auto_build

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(QMANPAGES)

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=3
opts=dversionmangle=s/[~+](dfsg|repack)(\.[0-9]*)?$//,uversionmangle=s/Link-\.// \
  https://github.com/Ableton/link/releases .*/(Link-)?(\d\S*)\.tar\.gz

## ableton-link 3.0.1%2Bdfsg

=== debian/changelog ===
ableton-link (3.0.1+dfsg-1) unstable; urgency=medium

  * New upstream version 3.0.1+dfsg

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ IOhannes m zmölnig ]
  * Imported upstream 3.0.1+dfsg
    * Refreshed patches (and removed those applied upstream)
  * d/rules: Removed dh boilerplate
  * d/control: Updated maintainer email address
  * d/control: Bumped standards version to 4.1.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 05 Mar 2018 15:28:56 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: ableton-link
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
-Uploaders: IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Uploaders:
+ IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends: debhelper (>= 9),
  cmake,
  catch,
  libasio-dev,
  libjack-dev,
  qtdeclarative5-dev,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: https://www.ableton.com/en/link/
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/ableton-link.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/ableton-link.git
+Vcs-Git: https://salsa.debian.org/multimedia-team/ableton-link.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/ableton-link
 
 Package: ableton-link-dev
 Architecture: all

## ableton-link 3.0.2+dfsg

=== debian/changelog ===
ableton-link (3.0.2+dfsg-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ IOhannes m zmölnig ]
  * Patch to fix missing includes (Closes: #956974)
  * Add salsa-ci configuration
  * Declare that building this package does not require 'root' powers.
  * Bump dh-compat to 13
  * Bump standards version to 4.5.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 27 Jul 2020 16:27:03 +0200

ableton-link (3.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version 3.0.2+dfsg
  * Bumped standards version to 4.1.4

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 03 Jun 2018 22:14:29 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,14 @@
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 13),
  cmake,
  catch,
  libasio-dev,
  libjack-dev,
  qtdeclarative5-dev,
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.ableton.com/en/link/
 Vcs-Git: https://salsa.debian.org/multimedia-team/ableton-link.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/ableton-link

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,4 @@
 #!/usr/bin/make -f
-# See debhelper(7) (uncomment to enable)
-# output every command that modifies files on the build system.
 #export DH_VERBOSE = 1
 
 QMANPAGES = debian/QLinkHut.1 debian/QLinkHutSilent.1
@@ -35,4 +33,3 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -f $(QMANPAGES)
-

## ableton-link 3.0.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,20 +11,13 @@
 #       |_|
 
 # Note: Please use the LINK_* prefix for all project-specific options
-option(LINK_BUILD_QT_EXAMPLES "Build examples (Requires Qt)" OFF)
 
 if(UNIX)
-  set(LINK_WORD_SIZE "64" CACHE STRING "Set the word size (must be either 32 or 64)")
   option(LINK_ENABLE_ASAN "Build with Address Sanitizier (ASan)" OFF)
+  option(LINK_BUILD_JACK "Build example applications with JACK support" OFF)
 endif()
 
 if(WIN32)
-  if(${CMAKE_GENERATOR} MATCHES "Win64")
-    set(LINK_WORD_SIZE "64")
-  else()
-    set(LINK_WORD_SIZE "32")
-  endif()
-
   option(LINK_BUILD_ASIO "Build example applications with ASIO driver" ON)
   option(LINK_BUILD_VLD "Build with VLD support (VLD must be installed separately)" OFF)
 endif()
@@ -38,7 +31,6 @@
 
 # Other CMake files must be included only after declaring build options
 include(cmake_include/ConfigureCompileFlags.cmake)
-include(cmake_include/ConfigureWordSize.cmake)
 include(cmake_include/CatchConfig.cmake)
 include(AbletonLinkConfig.cmake)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -72,10 +72,17 @@
     )
   endif()
 elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
-  set(linkhut_audio_SOURCES
-    linkaudio/AudioPlatform_Portaudio.hpp
-    linkaudio/AudioPlatform_Portaudio.cpp
-  )
+  if(LINK_BUILD_JACK)
+    set(linkhut_audio_SOURCES
+      linkaudio/AudioPlatform_Jack.hpp
+      linkaudio/AudioPlatform_Jack.cpp
+    )
+  else()
+    set(linkhut_audio_SOURCES
+      linkaudio/AudioPlatform_Portaudio.hpp
+      linkaudio/AudioPlatform_Portaudio.cpp
+    )
+  endif()
 endif()
 
 include_directories(linkaudio)
@@ -90,12 +97,10 @@
 
 function(configure_linkhut_executable target)
   if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
-    target_link_libraries(${target} pthread)
+    target_link_libraries(${target} atomic pthread)
   endif()
 
   target_link_libraries(${target} Ableton::Link)
-
-  target_set_word_size(${target})
 endfunction()
 
 function(configure_linkhut_audio_sources target)
@@ -105,10 +110,17 @@
       -DLINKHUT_AUDIO_PLATFORM_COREAUDIO=1
     )
   elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
-    target_link_libraries(${target} asound portaudio)
-    target_compile_definitions(${target} PRIVATE
-      -DLINKHUT_AUDIO_PLATFORM_PORTAUDIO=1
-    )
+    if(LINK_BUILD_JACK)
+      target_link_libraries(${target} jack)
+      target_compile_definitions(${target} PRIVATE
+        -DLINKHUT_AUDIO_PLATFORM_JACK=1
+      )
+    else()
+      target_link_libraries(${target} asound portaudio)
+      target_compile_definitions(${target} PRIVATE
+        -DLINKHUT_AUDIO_PLATFORM_PORTAUDIO=1
+      )
+    endif()
   elseif(WIN32)
     if(LINK_BUILD_ASIO)
       # ASIO uses lots of old-school string APIs from the C stdlib
@@ -131,7 +143,11 @@
   # When building LinkHut, additional warnings are generated from third-party frameworks
   set(extra_ignored_warnings_LIST
     "/wd4127" # conditional expression is constant
+    "/wd4242" # 'identifier' : conversion from 'type1' to 'type2', possible loss of data
+    "/wd4619" # #pragma warning : there is no warning number 'number'
+    "/wd4668" # 'symbol' is not defined as a preprocessor macro, replacing with '0' for 'directives'
     "/wd4702" # unreachable code
+    "/wd4946" # reinterpret_cast used between related classes: 'class1' and 'class2'
   )
   if(LINK_BUILD_ASIO)
     set(extra_ignored_warnings_LIST
@@ -139,6 +155,11 @@
       "/wd4267" # 'argument': conversion from '?' to '?', possible loss of data
       "/wd4477" # 'printf': format string '%?' requires an argument of type '?'
     )
+  else()
+    set(extra_ignored_warnings_LIST
+      ${extra_ignored_warnings_LIST}
+      "/wd4191" # 'operator/operation' : unsafe conversion from 'type of expression' to 'type required'
+    )
   endif()
   string(REPLACE ";" " " extra_ignored_warnings "${extra_ignored_warnings_LIST}")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${extra_ignored_warnings}")
@@ -171,67 +192,32 @@
 configure_linkhut_executable(LinkHut)
 source_group("LinkHut" FILES ${linkhut_HEADERS} ${linkhut_SOURCES})
 
-#   ___  _     _       _    _   _       _
-#  / _ \| |   (_)_ __ | | _| | | |_   _| |_
-# | | | | |   | | '_ \| |/ / |_| | | | | __|
-# | |_| | |___| | | | |   <|  _  | |_| | |_
-#  \__\_\_____|_|_| |_|_|\_\_| |_|\__,_|\__|
-#
-
-if(LINK_BUILD_QT_EXAMPLES)
-
-  set(CMAKE_AUTOMOC ON)
-  set(CMAKE_INCLUDE_CURRENT_DIR ON)
-
-  find_package(Qt5Quick REQUIRED)
-
-  set(qlinkhut_HEADERS
-    linkaudio/AudioEngine.hpp
-    linkaudio/AudioPlatform.hpp
-    qlinkhut/Controller.hpp
-    ${link_HEADERS}
-  )
-
-  set(qlinkhut_SOURCES
-    linkaudio/AudioEngine.cpp
-    qlinkhut/Controller.cpp
-    qlinkhut/main.cpp
-    ${link_SOURCES}
-  )
-  source_group("QLinkHut" FILES ${qlinkhut_HEADERS} ${qlinkhut_SOURCES})
-  qt5_add_resources(UI_RESOURCES qlinkhut/resources.qrc)
-
-  add_executable(QLinkHut
-    ${qlinkhut_HEADERS}
-    ${qlinkhut_SOURCES}
-    ${linkhut_audio_SOURCES}
-    ${UI_RESOURCES}
-  )
-  target_link_libraries(QLinkHut Qt5::Quick)
-  configure_linkhut_audio_sources(QLinkHut)
-  configure_linkhut_executable(QLinkHut)
-
-  # A silent version of QLinkHut that uses the Link application context instead of
-  # the audio buffer context. It is the same as QLinkHut except that it doesn't
-  # generate sound.
-
-  add_executable(QLinkHutSilent
-    ${qlinkhut_HEADERS}
-    ${qlinkhut_SOURCES}
-    linkaudio/AudioPlatform_Dummy.hpp
-    ${UI_RESOURCES}
-  )
-  target_link_libraries(QLinkHutSilent Qt5::Quick)
-
-  target_compile_definitions(QLinkHutSilent PRIVATE
-    -DLINKHUT_AUDIO_PLATFORM_DUMMY=1
-  )
-  if(UNIX)
-    set_target_properties(QLinkHutSilent
-      PROPERTIES
-      COMPILE_FLAGS "-Wno-unused"
-    )
-  endif()
-
-  configure_linkhut_executable(QLinkHutSilent)
-endif()
+#  _     _       _    _   _       _   ____  _ _            _
+# | |   (_)_ __ | | _| | | |_   _| |_/ ___|(_) | ___ _ __ | |_
+# | |   | | '_ \| |/ / |_| | | | | __\___ \| | |/ _ \ '_ \| __|
+# | |___| | | | |   <|  _  | |_| | |_ ___) | | |  __/ | | | |_
+# |_____|_|_| |_|_|\_\_| |_|\__,_|\__|____/|_|_|\___|_| |_|\__|
+#
+
+set(linkhutsilent_HEADERS
+  linkaudio/AudioEngine.hpp
+  linkaudio/AudioPlatform_Dummy.hpp
+  ${link_HEADERS}
+)
+
+set(linkhutsilent_SOURCES
+  linkaudio/AudioEngine.cpp
+  linkhut/main.cpp
+)
+
+add_executable(LinkHutSilent
+  ${linkhutsilent_HEADERS}
+  ${linkhutsilent_SOURCES}
+)
+
+target_compile_definitions(LinkHutSilent PRIVATE
+  -DLINKHUT_AUDIO_PLATFORM_DUMMY=1
+)
+
+configure_linkhut_executable(LinkHutSilent)
+source_group("LinkHutSilent" FILES ${linkhutsilent_HEADERS} ${linkhutsilent_SOURCES})

=== include/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,7 @@
 set(link_core_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/link)
 set(link_core_HEADERS
   ${link_core_DIR}/Beats.hpp
+  ${link_core_DIR}/CircularFifo.hpp
   ${link_core_DIR}/ClientSessionTimelines.hpp
   ${link_core_DIR}/Controller.hpp
   ${link_core_DIR}/Gateway.hpp
@@ -24,12 +25,15 @@
   ${link_core_DIR}/NodeId.hpp
   ${link_core_DIR}/NodeState.hpp
   ${link_core_DIR}/PayloadEntries.hpp
+  ${link_core_DIR}/Optional.hpp
   ${link_core_DIR}/Peers.hpp
   ${link_core_DIR}/PeerState.hpp
   ${link_core_DIR}/Phase.hpp
   ${link_core_DIR}/PingResponder.hpp
   ${link_core_DIR}/SessionId.hpp
+  ${link_core_DIR}/SessionState.hpp
   ${link_core_DIR}/Sessions.hpp
+  ${link_core_DIR}/StartStopState.hpp
   ${link_core_DIR}/Tempo.hpp
   ${link_core_DIR}/Timeline.hpp
   ${link_core_DIR}/v1/Messages.hpp
@@ -53,7 +57,6 @@
   ${link_discovery_DIR}/PeerGateway.hpp
   ${link_discovery_DIR}/PeerGateways.hpp
   ${link_discovery_DIR}/Service.hpp
-  ${link_discovery_DIR}/Socket.hpp
   ${link_discovery_DIR}/UdpMessenger.hpp
   ${link_discovery_DIR}/v1/Messages.hpp
   PARENT_SCOPE
@@ -69,16 +72,24 @@
 set(link_platform_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/platforms)
 set(link_platform_HEADERS
   ${link_platform_DIR}/Config.hpp
-  ${link_platform_DIR}/asio/AsioService.hpp
   ${link_platform_DIR}/asio/AsioTimer.hpp
   ${link_platform_DIR}/asio/AsioWrapper.hpp
   ${link_platform_DIR}/asio/Context.hpp
-  ${link_platform_DIR}/asio/PooledHandlerContext.hpp
+  ${link_platform_DIR}/asio/LockFreeCallbackDispatcher.hpp
   ${link_platform_DIR}/asio/Socket.hpp
   ${link_platform_DIR}/asio/Util.hpp
 )
 
-if(UNIX)
+if(ESP_PLATFORM)
+  set(link_platform_HEADERS
+    ${link_platform_HEADERS}
+    ${link_platform_DIR}/esp32/Clock.hpp
+    ${link_platform_DIR}/esp32/Context.hpp
+    ${link_platform_DIR}/esp32/Esp32.hpp
+    ${link_platform_DIR}/esp32/Random.hpp
+    ${link_platform_DIR}/esp32/ScanIpIfAddrs.hpp
+  )
+elseif(UNIX)
   set(link_platform_HEADERS
     ${link_platform_HEADERS}
     ${link_platform_DIR}/posix/ScanIpIfAddrs.hpp
@@ -89,19 +100,24 @@
       ${link_platform_HEADERS}
       ${link_platform_DIR}/darwin/Clock.hpp
       ${link_platform_DIR}/darwin/Darwin.hpp
+      ${link_platform_DIR}/stl/Random.hpp
     )
   elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
     set(link_platform_HEADERS
       ${link_platform_HEADERS}
+      ${link_platform_DIR}/linux/Clock.hpp
       ${link_platform_DIR}/linux/Linux.hpp
       ${link_platform_DIR}/stl/Clock.hpp
+      ${link_platform_DIR}/stl/Random.hpp
     )
   endif()
 elseif(WIN32)
   set(link_platform_HEADERS
     ${link_platform_HEADERS}
+    ${link_platform_DIR}/stl/Random.hpp
     ${link_platform_DIR}/windows/Clock.hpp
     ${link_platform_DIR}/windows/ScanIpIfAddrs.hpp
+    ${link_platform_DIR}/windows/Windows.hpp
   )
 endif()
 set(link_platform_HEADERS

=== examples/esp32/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(EXTRA_COMPONENT_DIRS $ENV{IDF_PATH}/examples/common_components/protocol_examples_common)

include($ENV{IDF_PATH}/tools/cmake/project.cmake)
project(link_esp32_example)

=== debian/changelog ===
ableton-link (3.0.3+dfsg-1) unstable; urgency=medium

  * Drop B-D and all references of Qt
  * Upload to unstable

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 13 Jan 2021 14:11:28 +0100

ableton-link (3.0.3+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 3.0.3+dfsg
    * Drop patches applied upstream
  * Remove 'ableton-link-utils-gui' package
    * upstream has removed the GUI-variants of the tools
  * Bump d/watch to version 4
  * Bump standards version to 4.5.1


 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 13 Jan 2021 09:46:09 +0100

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,7 @@
  catch,
  libasio-dev,
  libjack-dev,
- qtdeclarative5-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://www.ableton.com/en/link/
 Vcs-Git: https://salsa.debian.org/multimedia-team/ableton-link.git
@@ -46,19 +45,3 @@
  others will follow. Anyone can join or leave without disrupting the session.
  .
  This package contains cmdline utilities to check synchronisation.
-
-Package: ableton-link-utils-gui
-Architecture: any
-Depends:
- ${shlibs:Depends},
- ${misc:Depends},
- qml-module-qtquick-controls,
-Description: synchronizes musical applications on multiple devices - GUI utils
- Ableton Link, a technology that synchronizes musical beat, tempo, and phase
- across multiple applications running on one or more devices. Applications on
- devices connected to a local network discover each other automatically and form
- a musical session in which each participant can perform independently: anyone
- can start or stop while still staying in time. Anyone can change the tempo, the
- others will follow. Anyone can join or leave without disrupting the session.
- .
- This package contains GUI utilities to check synchronisation.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DLINK_BUILD_JACK=ON \
		$(empty)

override_dh_auto_build:
	dh_auto_build

override_dh_auto_clean:
	dh_auto_clean

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=4
opts=dversionmangle=s/[~+](dfsg|repack)(\.[0-9]*)?$//,uversionmangle=s/Link-\.// \
  https://github.com/Ableton/link/releases .*/(Link-)?(\d\S*)\.tar\.gz

## ableton-link 3.0.5+dfsg

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -11,9 +11,9 @@
 if(WIN32)
   function(configure_asio asio_sdk_path_OUT)
     # ASIO-related path/file variables
-    set(asio_download_root "https://www.steinberg.net/sdk_downloads")
-    set(asio_file_name "asiosdk2.3.zip")
-    set(asio_dir_name "ASIOSDK2.3")
+    set(asio_download_root "https:/download.steinberg.net/sdk_downloads")
+    set(asio_file_name "asiosdk_2.3.3_2019-06-14.zip")
+    set(asio_dir_name "asiosdk_2.3.3_2019-06-14")
     set(asio_working_dir "${CMAKE_BINARY_DIR}/modules")
     set(asio_output_path "${asio_working_dir}/${asio_file_name}")
 
@@ -71,7 +71,7 @@
       linkaudio/AudioPlatform_Wasapi.cpp
     )
   endif()
-elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+elseif(CMAKE_SYSTEM_NAME MATCHES "Linux|kFreeBSD|GNU")
   if(LINK_BUILD_JACK)
     set(linkhut_audio_SOURCES
       linkaudio/AudioPlatform_Jack.hpp
@@ -96,7 +96,7 @@
 #
 
 function(configure_linkhut_executable target)
-  if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+  if(CMAKE_SYSTEM_NAME MATCHES "Linux|kFreeBSD|GNU")
     target_link_libraries(${target} atomic pthread)
   endif()
 
@@ -109,7 +109,7 @@
     target_compile_definitions(${target} PRIVATE
       -DLINKHUT_AUDIO_PLATFORM_COREAUDIO=1
     )
-  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+  elseif(CMAKE_SYSTEM_NAME MATCHES "Linux|kFreeBSD|GNU")
     if(LINK_BUILD_JACK)
       target_link_libraries(${target} jack)
       target_compile_definitions(${target} PRIVATE

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -22,14 +22,16 @@
   ableton/link/tst_ClientSessionTimelines.cpp
   ableton/link/tst_Controller.cpp
   ableton/link/tst_HostTimeFilter.cpp
-  ableton/link/tst_Kalman.cpp
   ableton/link/tst_LinearRegression.cpp
   ableton/link/tst_Measurement.cpp
+  ableton/link/tst_Median.cpp
   ableton/link/tst_Peers.cpp
   ableton/link/tst_Phase.cpp
   ableton/link/tst_PingResponder.cpp
+  ableton/link/tst_StartStopState.cpp
   ableton/link/tst_Tempo.cpp
   ableton/link/tst_Timeline.cpp
+  ableton/link/tst_TripleBuffer.cpp
 )
 
 set(link_test_SOURCES
@@ -73,12 +75,11 @@
 #                |___/
 
 function(configure_link_test_executable target)
-  if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
-    target_link_libraries(${target} pthread)
+  if(CMAKE_SYSTEM_NAME MATCHES "Linux|kFreeBSD|GNU")
+    target_link_libraries(${target} atomic pthread)
   endif()
   target_link_libraries(${target} Catch::Catch Ableton::Link)
-
-  target_set_word_size(${target})
+  target_compile_definitions(${target} PRIVATE -DCATCH_CONFIG_ENABLE_BENCHMARKING=1)
 endfunction()
 
 # For the LinkCore test suite, we add header dependencies individually so that

=== debian/changelog ===
ableton-link (3.0.5+dfsg-1) unstable; urgency=medium

  * New upstream version 3.0.5+dfsg
    - Refresh patches
  * d/watch: automatic version mangling
  * d/copyright
    * Bump dates in d/copyright
    * Add 'licensecheck' target to d/rules
    * Generate original d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 19 Apr 2022 11:48:12 +0200

ableton-link (3.0.3+dfsg-6) unstable; urgency=medium

  * d/tests: allow stderr on build-examples-cmake test

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 21 Sep 2021 14:19:01 +0200

ableton-link (3.0.3+dfsg-5) unstable; urgency=medium

  * Fix compilation on kFreeBSD and the HURD (Closes: #842653)
  * Specify CMAKE_BUILD_TYPE to RelWithDebInfo
  * Install symlink for ableton-link-dev's CMake module
  * Add autopkgtest for building with cmake

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 10 Sep 2021 11:37:46 +0200

ableton-link (3.0.3+dfsg-4) unstable; urgency=medium

  * Fix FTBFS for separate indep/arch targets

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 09 Sep 2021 17:31:03 +0200

ableton-link (3.0.3+dfsg-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository, Repository-Browse.

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Drop useless dh overrides
  * Fix include paths in exported CMake snippets (Closes: #993999)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 09 Sep 2021 17:19:46 +0200

ableton-link (3.0.3+dfsg-2) unstable; urgency=medium

  * Mark dev-package as MultiArch:foreign
  * Bump standards version to 4.6.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 24 Aug 2021 17:25:51 +0200

=== debian/rules ===
--- 
+++ 
@@ -18,10 +18,16 @@
 	dh_auto_configure -- \
 		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
 		-DLINK_BUILD_JACK=ON \
+		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 		$(empty)
 
-override_dh_auto_build:
-	dh_auto_build
+override_dh_install-indep:
+	dh_install --indep
+	find $(CURDIR)/debian/ableton-link-dev/usr/share -name "*.cmake" -exec \
+		sed -e 's|$${CMAKE_CURRENT_LIST_DIR}/include|/usr/include|g' -i {} +
 
-override_dh_auto_clean:
-	dh_auto_clean
+licensecheck:
+	licensecheck --deb-machine -r * \
+		> debian/copyright_newhints
+	cmp debian/copyright_hints debian/copyright_newhints \
+		&& rm debian/copyright_newhints

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=4
opts=dversionmangle=auto,repacksuffix=+dfsg,uversionmangle=s/Link-\.// \
  https://github.com/Ableton/link/releases .*/(Link-)?(\d\S*)\.tar\.gz

## ableton-link 3.0.6+dfsg

=== debian/changelog ===
ableton-link (3.0.6+dfsg-4) unstable; urgency=medium

  * Unconditionally link clients against libatomic
  * Use generic build-dir for autopkgtests

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 12 Jan 2023 10:22:28 +0100

ableton-link (3.0.6+dfsg-3) unstable; urgency=medium

  * Fix typo in d/changelog

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 11 Jan 2023 12:40:17 +0100

ableton-link (3.0.6+dfsg-2) unstable; urgency=medium

  [ Adrian Bunk ]
  * Link with -latomic on architectures that need it

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 11 Jan 2023 11:13:10 +0100

ableton-link (3.0.6+dfsg-1) unstable; urgency=medium

  * New upstream version 3.0.6+dfsg
  * Disable building tests in the 'nocheck' profile
    + Drop B-D:catch in the 'nocheck' profile
  * Use execute_after_dh_* instead of override_dh_*
  * Modernize 'licensecheck' target
    + Re-generate d/copyright_hints
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 10 Jan 2023 23:07:34 +0100

ableton-link (3.0.5+dfsg-2) unstable; urgency=medium

  * Install developer examples
    * Add patch to ship usable examples
    * autopkgtest: drop obsolete on-the-fly patching
  * Install Cmake snippets into default place (instead of symlinking them)
  * Fix title of manpage
  * d/watch: switch to github/tags
  * Bump standards version to 4.6.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 28 Sep 2022 09:30:02 +0200

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,13 @@
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends:
+ catch <!nocheck>,
  cmake,
- catch,
+ debhelper-compat (= 13),
  libasio-dev,
  libjack-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.ableton.com/en/link/
 Vcs-Git: https://salsa.debian.org/multimedia-team/ableton-link.git
@@ -17,9 +18,10 @@
 
 Package: ableton-link-dev
 Architecture: all
+Multi-Arch: foreign
 Depends:
+ libasio-dev,
  ${misc:Depends},
- libasio-dev,
 Description: synchronizes musical applications on multiple devices - development
  Ableton Link, a technology that synchronizes musical beat, tempo, and phase
  across multiple applications running on one or more devices. Applications on
@@ -34,8 +36,8 @@
 Package: ableton-link-utils
 Architecture: any
 Depends:
+ ${misc:Depends},
  ${shlibs:Depends},
- ${misc:Depends},
 Description: synchronizes musical applications on multiple devices - cmdline utils
  Ableton Link, a technology that synchronizes musical beat, tempo, and phase
  across multiple applications running on one or more devices. Applications on

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,17 @@
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+CONFIGURE_FLAGS = -DLINK_BUILD_JACK=ON
+
+ifneq ($(filter nocheck,$(DEB_BUILD_PROFILES)),)
+CONFIGURE_FLAGS += -DLINK_BUILD_TESTS=OFF
+endif
+
+# workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
+ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc riscv64 sh4))
+export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
+endif
+
 %:
 	dh $@
 
@@ -17,17 +28,21 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
-		-DLINK_BUILD_JACK=ON \
 		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
-		$(empty)
+		$(CONFIGURE_FLAGS)
 
-override_dh_install-indep:
-	dh_install --indep
+execute_after_dh_install-indep:
 	find $(CURDIR)/debian/ableton-link-dev/usr/share -name "*.cmake" -exec \
 		sed -e 's|$${CMAKE_CURRENT_LIST_DIR}/include|/usr/include|g' -i {} +
 
+DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
+        debian/.*
+# licensecheck v1
+.PHONY: licensecheck
 licensecheck:
-	licensecheck --deb-machine -r * \
+	LANG=C.UTF-8 licensecheck \
+		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
+		--check '.*' --recursive --deb-machine --lines 0 * \
 		> debian/copyright_newhints
 	cmp debian/copyright_hints debian/copyright_newhints \
 		&& rm debian/copyright_newhints

## ableton-link 3.1.1+dfsg

=== debian/changelog ===
ableton-link (3.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 3.1.1+dfsg

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 05 Feb 2024 13:57:07 +0100

ableton-link (3.1.0+dfsg-2) unstable; urgency=medium

  * Fix FTBFS with catch3 (Closes: #1054677)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 30 Oct 2023 15:40:19 +0100

ableton-link (3.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 3.1.0+dfsg
    + Drop patches applied upstream
    + Refresh patches
  * Switch tests to catch2
  * Update copyright information
    + Bump copyright dates
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 26 Sep 2023 14:05:30 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
- catch <!nocheck>,
+ catch2 (>= 3~) <!nocheck>,
  cmake,
  debhelper-compat (= 13),
  libasio-dev,

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=4
opts="\
 uversionmangle=s/Link-\.//, \
 repacksuffix=+dfsg, \
 dversionmangle=auto" \
	https://github.com/Ableton/link/tags .*/(Link-)?(\d\S*)\.tar\.gz
